/**
	Definitions for "hola" program
	(this use OpenGL primitives and Qt)

	Fraga 19/09/2001
**/
#ifndef CUBE_H
#define CUBE_H

#include <QWidget>
#include <QtOpenGL>
#include <QTimer>

class Cube: public QGLWidget
{
	Q_OBJECT  // must include this if you use Qt signals/slots
public:
	Cube( QWidget *parent=0 );
	void createCube( float v[][3], float side );
	void showCube( float v[][3] );
	QSizePolicy sizePolicy() const;
	void getPosition ( int *x, int *y ) { *x = xmouse; *y = ymouse; }
	void getSize ( int *w, int *h ) { 
		*w = windowWidth; *h = windowHeight; 
	}
	void initCarasColor( void );

public slots:
	void timerDone( void );
	void initscreen( void ) { 
		timer->start(500);
	}
	void stop( void ) {
		timer->stop( );
 	} 

signals:
	void changePos( ); // called when mouse is moved
	void changeSize( ); // called when windows is resized
 
protected:
	void initializeGL( void );
	void resizeGL( int w, int h );
	void paintGL( void );
	void mouseMoveEvent( QMouseEvent * );
	void keyPressEvent ( QKeyEvent * e );
	// void mousePressEvent( QMouseEvent * );
 
 
private:
	QTimer *timer;

	int windowWidth, windowHeight;   // canvas width and height

	float yrot, xrot;  // Encene rotation

	float angle;
	int signo;
	int xmouse, ymouse;  // Mouse pointer coordinates

	float v[8][3]; // Instancia un cubo
	int caras[6][4];
	float color[6][3];
};


#endif // CUBO_H
